import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.math.BigInteger;
import java.util.Random;

public class Prime extends Applet implements ActionListener {
    Label numberLabel;
    Label probabilityLabel;
    Label resultLabel;

    TextField numberField;
    TextField probabilityField;

    Button okButton;

    public void init () {
	setLayout(null);

	numberLabel = new Label("Number :");
	add(numberLabel);
	numberLabel.setBounds(5, 5, 100, 20);

	probabilityLabel = new Label("Probability :");
	add(probabilityLabel);
	probabilityLabel.setBounds(5, 30, 100, 20);

	resultLabel = new Label("Result :");
	add(resultLabel);
	resultLabel.setBounds(5, 80, 400, 20);

	numberField = new TextField("");
	add(numberField);
	numberField.setBounds(110, 5, 350, 20);

	probabilityField = new TextField("");
	add(probabilityField);
	probabilityField.setBounds(110, 30, 100, 20);

	okButton = new Button("OK");
	add(okButton);
	okButton.setBounds(5, 55, 100, 20);

	okButton.addActionListener(this);
    }

    public void actionPerformed(ActionEvent e) {
	onOK();
    }

    void onOK() {
	resultLabel.setText("Result : Thinking ...");
	
	double probability = Double.valueOf(probabilityField.getText()).doubleValue();
	if (probability <= 0. || probability >= 1.) {
	    resultLabel.setText("Result : The probability must be more than 0 and less then 1");
	    return;
	}
	
	BigInteger p = new BigInteger(numberField.getText());
	int k = 0;
	double prob = 1.;
	while ( (1 - prob) < probability) {
	    prob *= 0.25;
	    k++;
	}

	int i = 0;
	BigInteger TWO = new BigInteger("2");
	BigInteger ONE = new BigInteger("1");
	BigInteger ZERO = new BigInteger("0");
	BigInteger MINUSONE = new BigInteger(p.subtract(ONE).toString());
	BigInteger q = new BigInteger(MINUSONE.toString());
	while (q.remainder(TWO).equals(ZERO)) {
	    q = q.divide(TWO);
	    i++;
	}

        Random rnd = new Random();
	int j = 0;
	int l = 0;
	for (j = 0; j < k; j++) {
	    BigInteger a = new BigInteger(p.bitLength() - 1, rnd);
	    a = a.add(TWO);

	    if (!p.gcd(a).equals(ONE) || !a.modPow(MINUSONE, p).equals(ONE)) {
		resultLabel.setText("Result : This number is composite");
		return;
	    }

	    for (l = 0; l <= i; l++) {
		if (l == 0) {
		    a = a.modPow(q, p);
		} else if (l < i && a.modPow(TWO, p).equals(ONE) && !a.equals(ONE) && !a.equals(MINUSONE)) {
		    resultLabel.setText("Result : This number is composite");
		    return;
		} else {
		    a = a.modPow(TWO, p);
		}
	    }
	}

	resultLabel.setText("Result : With the probability " + (1 - prob) + " this number is prime");
	return;
    }
}